"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.min = void 0;
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
function min(source, selector) {
    if (selector) {
        return min2(source, selector);
    }
    else {
        return min1(source);
    }
}
exports.min = min;
const min1 = async (source) => {
    let minValue = null;
    for await (const item of source) {
        minValue = Math.min(minValue || Number.POSITIVE_INFINITY, item);
    }
    if (minValue === null) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    else {
        return minValue;
    }
};
const min2 = async (source, selector) => {
    let minValue = null;
    for await (const item of source) {
        minValue = Math.min(minValue || Number.POSITIVE_INFINITY, selector(item));
    }
    if (minValue === null) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    else {
        return minValue;
    }
};
